/* -*- mode: c++; c-basic-offset: 4; -*- */
#ifndef BASH_PAT_WRAP_HH
#define BASH_PAT_WRAP_HH

#include <string>

struct bash_pattern_t;

/**  C++ wrapper for Leo's bash_pattern functions.
 */
class bashpat_wrap {
public:
  /** Constructor
   */
  bashpat_wrap(const std::string& pat);

  /**  Destructor
   */
  ~bashpat_wrap(void);

  /** Compile a pattern string... This is needed only if the pattern is not
    *  specified to the constructor.
    */
  void compile(const std::string& pat);

  /**  Get the initial literal portion of the pattern string.
   */
  std::string literal(void) const;

  /**  Test whether the specified string matches the compiled wrapper.
   */
  bool match(const std::string& str) const;

  /**  Test whether a valid pattern has been compiled.
    */
  bool ok(void) const;

private:
  bash_pattern_t* bp_struct;
};  

inline bool
bashpat_wrap::ok(void) const {
    return bp_struct != NULL;
}


#endif //!defined(BASH_PAT_WRAP_HH)
