#ifndef SENDS_MISC_HELPERS_HH
#define SENDS_MISC_HELPERS_HH

namespace sends {

	/// \brief A simple class to automatically call a close method on a ptr.  This does not manage ownership.
    template <typename T> class auto_closer {
    public:
    	auto_closer(T &obj): mObj(obj) {}
    	~auto_closer() { mObj.close(); }
    private:
    	T &mObj;

    	auto_closer(const auto_closer<T> &other);
    	auto_closer &operator=(const auto_closer<T> &other);
    };

}

#endif // !defined(SENDS_MISC_HELPERS_HH)