#ifndef SENDS_UPDATE_USERS_HH
#define SENDS_UPDATE_USERS_HH

#include "thread_base.hh"
#include "gateway.hh"

namespace sends {

	/** The user_list_update class is the logic for the user list updater thread.
	  * Every minute the thread will wake up and see if the userlist file has been updated.
	  * If it has been updated the global user list is updated.
	  */
	class user_list_update : public thread::thread_base {
	public:
		user_list_update(const std::string& userfile_name);
		~user_list_update();

		/** The thread main loop.
		  * @returns NULL
		  */
		void *thread_entry();

	private:
		user_list_update &operator=(const user_list_update& other);
		mutable thread::gateway mWaitGateway;

		std::string mUserFileName;
	};

}

#endif // SENDS_UPDATE_USERS_HH